# -*- coding: iso-8859-1 -*-
#
# John Plugin by gutemine
#
john_version = "0.1"
#
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.Console import Console
from Components.ActionMap import ActionMap
from Components.Label import Label, MultiColorLabel
from GlobalActions import globalActionMap
import os

def main(session,**kwargs):
	session.open(ShowJohn)

def Plugins(**kwargs):
	return [PluginDescriptor(name="John the Ripper", description=_("password crack & reset"), where = PluginDescriptor.WHERE_PLUGINMENU, icon="john.png", fnc=main),
            PluginDescriptor(name=_("John the Ripper"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]

class ShowJohn(Screen):
	skin = """
		<screen position="center,center" size="550,120" title="John the Ripper" >
		<widget name="buttonred" position="10,60" size="120,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttongreen" position="140,60" size="120,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttonyellow" position="270,60" size="120,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttonblue" position="400,60" size="120,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		</screen>"""
	def __init__(self, session):
		Screen.__init__(self, session)
		self.skin = ShowJohn.skin
		self["buttonred"] = Label(_("Cancel"))
		self["buttongreen"] = Label(_("Crack"))
		self["buttonyellow"] = Label(_("Reset"))
		self["buttonblue"] = Label(_("About"))
                self["setupActions"] = ActionMap([ "ColorActions", "SetupActions" ],                         
                        {                                                                                    
                        "green": self.crack,                                                                  
                        "red": self.cancel,                                                                  
                        "yellow": self.reset,                                                               
                        "blue": self.about,                                                                  
                        "save": self.save,                                                                   
                        "cancel": self.cancel,                                                               
                        "ok": self.save,                                                                     
                        })                                                                                   

	def setWindowTitle(self):
		self.setTitle(_("John the Ripper"))

	def crack(self):
		if os.path.exists("/etc/shadow"):
			os.system("unshadow /etc/passwd /etc/shadow > /tmp/passwd")
                	self.session.open(Console,_("john is now cracking, be patient ..."),["john /tmp/passwd" ])
		else:
			self.session.open(MessageBox, _("no /etc/shadow found"), MessageBox.TYPE_ERROR)

	def save(self):
		self.close(True)

	def cancel(self):
		self.close(False)

	def reset(self):
	   	f = open("/etc/passwd","r")               
   		text = f.readline()                             
   		text = f.read()                             
   		f.close
		text="root::0:0:root:/home/root:/bin/sh\n"+text
	   	f = open("/etc/passwd","w")               
  		f.write(text)
                f.close
		self.session.open(MessageBox, _("Password was reset to blank"), MessageBox.TYPE_INFO)
 
	def about(self):
		self.session.open(MessageBox, _("John the Ripper for Enigma2 V%s\nby gutemine") % john_version, MessageBox.TYPE_INFO)
